Index: /pjproject/branches/projects/aps-direct/pjmedia/build/pjmedia.dsp
===================================================================
--- /pjproject/branches/projects/aps-direct/pjmedia/build/pjmedia.dsp	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjmedia/build/pjmedia.dsp	(revision 2468)
@@ -122,8 +122,4 @@
 # Begin Source File
 
-SOURCE=..\src\pjmedia\dsound.c
-# End Source File
-# Begin Source File
-
 SOURCE=..\src\pjmedia\echo_common.c
 # End Source File
@@ -178,12 +174,4 @@
 # Begin Source File
 
-SOURCE=..\src\pjmedia\nullsound.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\pasound.c
-# End Source File
-# Begin Source File
-
 SOURCE=..\src\pjmedia\plc_common.c
 # End Source File
@@ -295,8 +283,4 @@
 
 SOURCE=..\src\pjmedia\wave.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjmedia\wmme_sound.c
 # End Source File
 # Begin Source File
Index: /pjproject/branches/projects/aps-direct/pjmedia/build/pjmedia_audiodev.dsp
===================================================================
--- /pjproject/branches/projects/aps-direct/pjmedia/build/pjmedia_audiodev.dsp	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjmedia/build/pjmedia_audiodev.dsp	(revision 2468)
@@ -102,4 +102,14 @@
 # Begin Source File
 
+SOURCE="..\src\pjmedia-audiodev\symb_aps_dev.cpp"
+# PROP Exclude_From_Build 1
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjmedia-audiodev\symb_mda_dev.cpp"
+# PROP Exclude_From_Build 1
+# End Source File
+# Begin Source File
+
 SOURCE="..\src\pjmedia-audiodev\wmme_dev.c"
 # End Source File
Index: /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia-audiodev/audiodev.h
===================================================================
--- /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia-audiodev/audiodev.h	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia-audiodev/audiodev.h	(revision 2468)
@@ -18,6 +18,6 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
  */
-#ifndef __AUDIODEV_H__
-#define __AUDIODEV_H__
+#ifndef __PJMEDIA_AUDIODEV_AUDIODEV_H__
+#define __PJMEDIA_AUDIODEV_AUDIODEV_H__
 
 /**
@@ -52,9 +52,19 @@
  */
 
-/** Device identifier */
-typedef pj_int32_t pjmedia_aud_dev_id;
-
-/** Constant to denote default ID */
-#define PJMEDIA_AUD_DEV_DEFAULT_ID  (-1)
+/** 
+ * Type for device index.
+ */
+typedef pj_int32_t pjmedia_aud_dev_index;
+
+/** 
+ * Constant to denote default device 
+ */
+#define PJMEDIA_AUD_DEV_DEFAULT  (-1)
+
+/** 
+ * Type for device unique identifier. The unique device ID can be used to save
+ * a reference to a particular device across software reboots.
+ */
+typedef pj_uint32_t pjmedia_aud_dev_uid;
 
 
@@ -67,5 +77,5 @@
  *
  * Application can also set the specific features/capabilities when opening
- * the audio stream by setting the \a flags member of #pjmedia_aud_dev_param
+ * the audio stream by setting the \a flags member of #pjmedia_aud_param
  * structure.
  *
@@ -118,5 +128,5 @@
      * the audio volume in percent.
      */
-    PJMEDIA_AUD_DEV_CAP_INPUT_SIGNAL_VOLUME = 32,
+    PJMEDIA_AUD_DEV_CAP_INPUT_SIGNAL_METER = 32,
 
     /** 
@@ -125,5 +135,5 @@
      * the audio volume in percent.
      */
-    PJMEDIA_AUD_DEV_CAP_OUTPUT_SIGNAL_VOLUME = 64,
+    PJMEDIA_AUD_DEV_CAP_OUTPUT_SIGNAL_METER = 64,
 
     /** 
@@ -142,5 +152,5 @@
     /** 
      * The audio device has echo cancellation feature. The value of this
-     * capability is an integer containing boolean PJ_TRUE or PJ_FALSE.
+     * capability is a pj_bool_t containing boolean PJ_TRUE or PJ_FALSE.
      */
     PJMEDIA_AUD_DEV_CAP_EC = 512,
@@ -155,5 +165,5 @@
     /** 
      * The audio device has voice activity detection feature. The value
-     * of this capability is an integer containing boolean PJ_TRUE or 
+     * of this capability is a pj_bool_t containing boolean PJ_TRUE or 
      * PJ_FALSE.
      */
@@ -162,5 +172,5 @@
     /** 
      * The audio device has comfort noise generation feature. The value
-     * of this capability is an integer containing boolean PJ_TRUE or 
+     * of this capability is a pj_bool_t containing boolean PJ_TRUE or 
      * PJ_FALSE.
      */
@@ -169,5 +179,5 @@
     /** 
      * The audio device has packet loss concealment feature. The value
-     * of this capability is an integer containing boolean PJ_TRUE or 
+     * of this capability is a pj_bool_t containing boolean PJ_TRUE or 
      * PJ_FALSE.
      */
@@ -226,5 +236,5 @@
      * The underlying driver name 
      */
-    char driver[128];
+    char driver[32];
 
     /** 
@@ -290,7 +300,7 @@
 
 /**
- * This structure specifies the parameters to open the audio device stream.
- */
-typedef struct pjmedia_aud_dev_param
+ * This structure specifies the parameters to open the audio stream.
+ */
+typedef struct pjmedia_aud_param
 {
     /**
@@ -303,5 +313,5 @@
      * direction includes input/capture direction.
      */
-    pjmedia_aud_dev_id rec_id;
+    pjmedia_aud_dev_index rec_id;
 
     /**
@@ -309,5 +319,5 @@
      * direction includes output/playback direction.
      */
-    pjmedia_aud_dev_id play_id;
+    pjmedia_aud_dev_index play_id;
 
     /** 
@@ -387,5 +397,5 @@
     pj_bool_t cng_enabled;
 
-} pjmedia_aud_dev_param;
+} pjmedia_aud_param;
 
 
@@ -432,4 +442,17 @@
 
 /**
+ * Get string info for the specified capability.
+ *
+ * @param cap		The capability ID.
+ * @param p_desc	Optional pointer which will be filled with longer 
+ *			description about the capability.
+ *
+ * @return		Capability name.
+ */
+PJ_DECL(const char*) pjmedia_aud_dev_cap_name(pjmedia_aud_dev_cap cap,
+					      const char **p_desc);
+
+
+/**
  * Get the number of sound devices installed in the system.
  *
@@ -438,15 +461,4 @@
 PJ_DECL(unsigned) pjmedia_aud_dev_count(void);
 
-
-/**
- * Enumerate device ID's.
- *
- * @param max_count	Maximum number of device id's to retrieve.
- * @param ids		Array to receive the device id's.
- *
- * @return		The actual number of device id's filled in.
- */
-PJ_DECL(unsigned) pjmedia_aud_dev_enum(unsigned max_count,
-				       pjmedia_aud_dev_id ids[]);
 
 /**
@@ -460,6 +472,19 @@
  *			error code.
  */
-PJ_DECL(pj_status_t) pjmedia_aud_dev_get_info(pjmedia_aud_dev_id id,
+PJ_DECL(pj_status_t) pjmedia_aud_dev_get_info(pjmedia_aud_dev_index id,
 					      pjmedia_aud_dev_info *info);
+
+
+/**
+ * Lookup device index based on the driver and device name.
+ *
+ * @param drv_name	The driver name.
+ * @param dev_name	The device name.
+ *
+ * @return		PJ_SUCCESS if the device can be found.
+ */
+PJ_DECL(pj_status_t) pjmedia_aud_dev_lookup(const char *drv_name,
+					    const char *dev_name,
+					    pjmedia_aud_dev_index *id);
 
 
@@ -475,6 +500,6 @@
  *			error code.
  */
-PJ_DECL(pj_status_t) pjmedia_aud_dev_default_param(pjmedia_aud_dev_id id,
-						   pjmedia_aud_dev_param *param);
+PJ_DECL(pj_status_t) pjmedia_aud_dev_default_param(pjmedia_aud_dev_index id,
+						   pjmedia_aud_param *param);
 
 
@@ -493,9 +518,9 @@
  *			error code.
  */
-PJ_DECL(pj_status_t) pjmedia_aud_stream_create(const pjmedia_aud_dev_param *param,
+PJ_DECL(pj_status_t) pjmedia_aud_stream_create(const pjmedia_aud_param *param,
 					       pjmedia_aud_rec_cb rec_cb,
 					       pjmedia_aud_play_cb play_cb,
 					       void *user_data,
-					       pjmedia_aud_stream **p_aud_strm);
+					       pjmedia_aud_stream **p_strm);
 
 /**
@@ -510,5 +535,5 @@
  */
 PJ_DECL(pj_status_t) pjmedia_aud_stream_get_param(pjmedia_aud_stream *strm,
-						  pjmedia_aud_dev_param *param);
+						  pjmedia_aud_param *param);
 
 /**
@@ -581,4 +606,7 @@
 #define PJMEDIA_EAUD_NOTREADY	-1
 
+/* Invalid audio capability or audio capability not supported */
+#define PJMEDIA_EAUD_INVCAP	-1
+
 /* Unknown system error */
 #define PJMEDIA_EAUD_SYSERR	-1
@@ -592,4 +620,4 @@
 
 
-#endif	/* __AUDIODEV_H__ */
-
+#endif	/* __PJMEDIA_AUDIODEV_AUDIODEV_H__ */
+
Index: /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia-audiodev/audiodev_imp.h
===================================================================
--- /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia-audiodev/audiodev_imp.h	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia-audiodev/audiodev_imp.h	(revision 2468)
@@ -80,5 +80,5 @@
     pj_status_t (*default_param)(pjmedia_aud_dev_factory *f,
 				 unsigned index,
-				 pjmedia_aud_dev_param *param);
+				 pjmedia_aud_param *param);
 
     /**
@@ -87,5 +87,5 @@
      */
     pj_status_t (*create_stream)(pjmedia_aud_dev_factory *f,
-				 const pjmedia_aud_dev_param *param,
+				 const pjmedia_aud_param *param,
 				 pjmedia_aud_rec_cb rec_cb,
 				 pjmedia_aud_play_cb play_cb,
@@ -120,5 +120,5 @@
      */
     pj_status_t (*get_param)(pjmedia_aud_stream *strm,
-			     pjmedia_aud_dev_param *param);
+			     pjmedia_aud_param *param);
 
     /**
@@ -159,6 +159,6 @@
 struct pjmedia_aud_stream
 {
-    /** Factory */
-    pjmedia_aud_dev_factory *factory;
+    /** Factory id (internal) */
+    unsigned factory_id;
 
     /** Operations */
Index: /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia-audiodev/audiotest.h
===================================================================
--- /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia-audiodev/audiotest.h	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia-audiodev/audiotest.h	(revision 2468)
@@ -18,6 +18,6 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
  */
-#ifndef __AUDIOTEST_H__
-#define __AUDIOTEST_H__
+#ifndef __PJMEDIA_AUDIODEV_AUDIOTEST_H__
+#define __PJMEDIA_AUDIODEV_AUDIOTEST_H__
 
 /**
@@ -92,5 +92,5 @@
  * Perform audio device testing.
  */
-PJ_DECL(pj_status_t) pjmedia_aud_test(const pjmedia_aud_dev_param *param,
+PJ_DECL(pj_status_t) pjmedia_aud_test(const pjmedia_aud_param *param,
 				      pjmedia_aud_test_results *result);
 
@@ -102,5 +102,5 @@
 
 
-#endif	/* __AUDIOTEST_H__ */
+#endif	/* __PJMEDIA_AUDIODEV_AUDIOTEST_H__ */
 
 
Index: /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia.h
===================================================================
--- /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia.h	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia.h	(revision 2468)
@@ -53,5 +53,8 @@
 #include <pjmedia/session.h>
 #include <pjmedia/silencedet.h>
+/* This sound API is deprecated. Please see:
+http://trac.pjsip.org/repos/wiki/Audio_Dev_API
 #include <pjmedia/sound.h>
+*/
 #include <pjmedia/sound_port.h>
 #include <pjmedia/splitcomb.h>
Index: /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/config.h
===================================================================
--- /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/config.h	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/config.h	(revision 2468)
@@ -65,71 +65,53 @@
  */
 
-/** Constant for NULL sound backend. */
-#define PJMEDIA_SOUND_NULL_SOUND	    0
-
-/** Constant for PortAudio sound backend. */
-#define PJMEDIA_SOUND_PORTAUDIO_SOUND	    1
-
-/** Constant for Win32 DirectSound sound backend. */
-#define PJMEDIA_SOUND_WIN32_DIRECT_SOUND    2
-
-/** Constant for Win32 MME sound backend. */
-#define PJMEDIA_SOUND_WIN32_MME_SOUND	    3
-
-/** Constant for Symbian Multimedia Audio Stream backend. */
-#define PJMEDIA_SOUND_SYMB_MDA_SOUND	    4
-
-/** Constant for Symbian APS backend. */
-#define PJMEDIA_SOUND_SYMB_APS_SOUND	    5
-
-/** Constant for Symbian VAS backend. */
-#define PJMEDIA_SOUND_SYMB_VAS_SOUND	    6
-
-
-/** When this is set, pjmedia will not provide any sound device backend. 
- *  Application will have to provide its own sound device backend
- *  and link the application with it.
- */
-#define PJMEDIA_SOUND_EXTERNAL		    255
-
-
-/**
- * Unless specified otherwise, sound device uses PortAudio implementation
- * by default.
- */
-#ifndef PJMEDIA_SOUND_IMPLEMENTATION
-#  if defined(PJ_WIN32) && PJ_WIN32!=0
-/*#   define PJMEDIA_SOUND_IMPLEMENTATION   PJMEDIA_SOUND_WIN32_DIRECT_SOUND*/
-/*#   define PJMEDIA_SOUND_IMPLEMENTATION   PJMEDIA_SOUND_WIN32_MME_SOUND*/
-#   define PJMEDIA_SOUND_IMPLEMENTATION	    PJMEDIA_SOUND_PORTAUDIO_SOUND
-#  else
-#   define PJMEDIA_SOUND_IMPLEMENTATION	    PJMEDIA_SOUND_PORTAUDIO_SOUND
-#  endif
-#endif
-
-/**
- * Specify if the sound device implementation supports handling encoded
- * frames. Setting this to zero will activate some emulation in the
- * sound port.
- */
-#if PJMEDIA_SOUND_IMPLEMENTATION==PJMEDIA_SOUND_SYMB_APS_SOUND || \
-    PJMEDIA_SOUND_IMPLEMENTATION==PJMEDIA_SOUND_SYMB_VAS_SOUND
-#   define PJMEDIA_SND_SUPPORT_OPEN2	1
-#else
-#   define PJMEDIA_SND_SUPPORT_OPEN2	0
-#endif
-
-/**
- * Specify whether we prefer to use DirectSound on Windows.
- *
- * Default: 0
- */
-#ifndef PJMEDIA_PREFER_DIRECT_SOUND
-#   define PJMEDIA_PREFER_DIRECT_SOUND	    0
-#endif
-
-
-/**
- * Specify sound device latency default, in milisecond.
+/**
+ * This macro has been deprecated in releasee 1.1. Please see
+ * http://trac.pjsip.org/repos/wiki/Audio_Dev_API for more information.
+ */
+#if defined(PJMEDIA_SOUND_IMPLEMENTATION)
+#   error PJMEDIA_SOUND_IMPLEMENTATION has been deprecated
+#endif
+
+/**
+ * This macro has been deprecated in releasee 1.1. Please see
+ * http://trac.pjsip.org/repos/wiki/Audio_Dev_API for more information.
+ */
+#if defined(PJMEDIA_PREFER_DIRECT_SOUND)
+#   error PJMEDIA_PREFER_DIRECT_SOUND has been deprecated
+#endif
+
+/**
+ * Setting PJMEDIA_AUDIO_API to this value will completely deprecate the use
+ * of old API, and inclusion of <pjmedia/sound.h> in the code will raise 
+ * compilation error.
+ */
+#define PJMEDIA_AUDIO_API_NEW_ONLY	    1
+
+/**
+ * Setting PJMEDIA_AUDIO_API to this value enables application to use the old
+ * sound device API to access audio devices provided by the new audio device 
+ * API. 
+ */
+#define PJMEDIA_AUDIO_API_HAS_OLD_API	    2
+
+/**
+ * Setting PJMEDIA_AUDIO_API to this value enables old sound device 
+ * implementation to be accessed via both old and new API's. 
+ */
+#define PJMEDIA_AUDIO_API_HAS_OLD_DEVICE    3
+
+/**
+ * Specify how the audio API should handle compatibility with old sound API.
+ * Valid values are: PJMEDIA_AUDIO_API_HAS_OLD_API (default, 
+ * PJMEDIA_AUDIO_API_NEW_ONLY, or PJMEDIA_AUDIO_API_HAS_OLD_DEVICE. Please
+ * see http://trac.pjsip.org/repos/wiki/Audio_Dev_API for more info.
+ */
+#ifndef PJMEDIA_AUDIO_API
+#   define PJMEDIA_AUDIO_API		    PJMEDIA_AUDIO_API_NEW_ONLY
+#endif
+
+
+/**
+ * Specify default sound device latency, in milisecond.
  */
 #ifndef PJMEDIA_SND_DEFAULT_REC_LATENCY
@@ -137,22 +119,9 @@
 #endif
 
+/**
+ * Specify default sound device latency, in milisecond.
+ */
 #ifndef PJMEDIA_SND_DEFAULT_PLAY_LATENCY
 #   define PJMEDIA_SND_DEFAULT_PLAY_LATENCY 100
-#endif
-
-
-/**
- * Specify whether delay buffer is used for sound device.
- * When delay buffer is enabled, the sound device callback 
- * will be called one after another evenly.
- * The delay buffer also performs the best delay calculation
- * for the sound device, and will try to limit the delay caused
- * by uneven callback calls to this delay.
- *
- * When this setting is enabled, the PJMEDIA_SOUND_BUFFER_COUNT
- * macro will specify the maximum size of the delay buffer.
- */
-#ifndef PJMEDIA_SOUND_USE_DELAYBUF
-#   define PJMEDIA_SOUND_USE_DELAYBUF	    0
 #endif
 
Index: /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/endpoint.h
===================================================================
--- /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/endpoint.h	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/endpoint.h	(revision 2468)
@@ -38,5 +38,4 @@
  */
 
-#include <pjmedia/sound.h>
 #include <pjmedia/codec.h>
 #include <pjmedia/sdp.h>
Index: /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/sound.h
===================================================================
--- /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/sound.h	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/sound.h	(revision 2468)
@@ -20,4 +20,13 @@
 #ifndef __PJMEDIA_SOUND_H__
 #define __PJMEDIA_SOUND_H__
+
+
+/* This is legacy sound device code, which has been superseded by the
+ * new pjmedia-audiodev framework. Please see the documentation on how
+ * to use this legacy API.
+ */
+#if PJMEDIA_AUDIO_API==PJMEDIA_AUDIO_API_NEW_ONLY
+#   error "The sound device API is deprecated. Please see doc for details."
+#endif
 
 
Index: /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/sound_port.h
===================================================================
--- /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/sound_port.h	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/sound_port.h	(revision 2468)
@@ -25,5 +25,5 @@
  * @brief Media port connection abstraction to sound device.
  */
-#include <pjmedia/sound.h>
+#include <pjmedia-audiodev/audiodev.h>
 #include <pjmedia/port.h>
 
@@ -163,23 +163,8 @@
 
 /**
- * Create unidirectional or bidirectional sound port. This also allows
- * creating sound port with extended settings, e.g: audio format, see 
- * #pjmedia_snd_setting.
- *
- * @param pool		    Pool to allocate sound port structure.
- * @param dir		    Sound device direction.
- * @param rec_id	    Device index for recorder/capture stream, or
- *			    -1 to use the first capable device.
- * @param play_id	    Device index for playback stream, or -1 to use 
- *			    the first capable device.
- * @param clock_rate	    Sound device's clock rate to set.
- * @param channel_count	    Set number of channels, 1 for mono, or 2 for
- *			    stereo. The channel count determines the format
- *			    of the frame.
- * @param samples_per_frame Number of samples per frame.
- * @param bits_per_sample   Set the number of bits per sample. The normal 
- *			    value for this parameter is 16 bits per sample.
- * @param setting	    Sound device extended settings, see 
- *			    #pjmedia_snd_setting.
+ * Create sound device port according to the specified parameters.
+ *
+ * @param pool		    Pool to allocate sound port structure.
+ * @param prm		    Sound device settings.
  * @param p_port	    Pointer to receive the sound device port instance.
  *
@@ -188,12 +173,5 @@
  */
 PJ_DECL(pj_status_t) pjmedia_snd_port_create2(pj_pool_t *pool,
-					      pjmedia_dir dir,
-					      int rec_id,
-					      int play_id,
-					      unsigned clock_rate,
-					      unsigned channel_count,
-					      unsigned samples_per_frame,
-					      unsigned bits_per_sample,
-					      const pjmedia_snd_setting *setting,
+					      const pjmedia_aud_param *prm,
 					      pjmedia_snd_port **p_port);
 
@@ -217,17 +195,21 @@
  * @return		    The sound stream instance.
  */
-PJ_DECL(pjmedia_snd_stream*) pjmedia_snd_port_get_snd_stream(
+PJ_DECL(pjmedia_aud_stream*) pjmedia_snd_port_get_snd_stream(
 						pjmedia_snd_port *snd_port);
 
 
 /**
- * Configure the echo cancellation tail length. By default, echo canceller
- * is enabled in the sound device with the default tail length. After the
- * sound port is created, application can query the current echo canceller
- * tail length by calling #pjmedia_snd_port_get_ec_tail.
- *
- * Note that you should only change the EC settings when the sound port
- * is not connected to any downstream ports, otherwise race condition may
- * occur.
+ * Change the echo cancellation settings. The echo cancellation settings 
+ * should have been specified when this sound port was created, by setting
+ * the appropriate fields in the pjmedia_aud_param, because not all sound
+ * device implementation supports changing the EC setting once the device
+ * has been opened.
+ *
+ * The behavior of this function depends on whether device or software AEC
+ * is being used. If the device supports AEC, this function will forward
+ * the change request to the device and it will be up to the device whether
+ * to support the request. If software AEC is being used (the software EC
+ * will be used if the device does not support AEC), this function will
+ * change the software EC settings.
  *
  * @param snd_port	    The sound device port.
@@ -237,4 +219,5 @@
  *			    be disabled.
  * @param options	    The options to be passed to #pjmedia_echo_create().
+ *			    This is only used if software EC is being used.
  *
  * @return		    PJ_SUCCESS on success.
Index: /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/stream.h
===================================================================
--- /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/stream.h	(revision 2467)
+++ /pjproject/branches/projects/aps-direct/pjmedia/include/pjmedia/stream.h	(revision 2468)
@@ -27,5 +27,4 @@
  */
 
-#include <pjmedia/sound.h>
 #include <pjmedia/codec.h>
 #include <pjmedia/endpoint.h>
